﻿using WoodPelletShop;
//---------------------------------------------- WoodPellet -----------------------------------------------------------------------------

//Her oprettes et enkelt WoodPellet objekt via constructor med parameter:
WoodPellet woodPellet = new WoodPellet("BioWood", "Premium", "6mm", 4995.00, "4,94 kwh/kg", "4,3%", 20, "1 Palle indeholder 64 poser af 15 kg");
Console.WriteLine("First WoodPellet Object:");
Console.WriteLine(woodPellet);
Console.WriteLine();

//Her oprettes et nyt WoodPellets objekt via "default" constructor (den uden parametre)
WoodPellet woodPellet1 = new WoodPellet();

//Objektet er "tomt" eneste værdi der er tildelt er Id via nextId
Console.WriteLine("Second Woodpellet Object, created with the default constructor: ");
Console.WriteLine(woodPellet1);
Console.WriteLine();

//Her tildeles det "tomme" objekt værdier via set-metoderne (Properties)
woodPellet1.Brand = "BioWood";
woodPellet1.Quality = "High";
woodPellet1.Size = "8mm";
woodPellet1.Price = 5499.00;
woodPellet1.Energy = "4,91 kwh/kg";
woodPellet1.Humidity = "4,5%";
woodPellet1.Stock = 45;
woodPellet1.Info = "1 Palle indeholder 64 poser af 15 kg";

Console.WriteLine("Second Woodpellet Object, after assigning the values to the properties:");
Console.WriteLine(woodPellet1);
Console.WriteLine();


//------------------------------------------------- Customer -----------------------------------------------------------------------------


//Her afprøves at vi kan oprette et Customer objekt via constructor med parametre:
Customer customer = new Customer("Jens Hansen", "22334455", "jhansen@private.dk", new Address("Skovvej", "55A", "Skovlunde", "2740"));
Console.WriteLine("First Customer Object:");
Console.WriteLine(customer);
Console.WriteLine();


//------------------------------------------------- Order --------------------------------------------------------------------------------

//Her afprøves at vi kan oprette et Order objekt med referencer til de første WoodPellet og Customer objekter
//Bemærk der oprettes nye DateOnly objekter til OrderDate og DeleveryDate, parameterne er År, Måned, Dag
//Bemærk også, at vi henter Customers adresse og benytter den som DeleveryAddress

Order order = new Order(woodPellet, customer, 2, new DateOnly(2022, 10, 12), new DateOnly(2022, 11, 24), customer.Address);
Console.WriteLine("First Order of the first woodpellet to the first customer:");
Console.WriteLine(order);
Console.WriteLine();

//Noter: Det er meningen at der oprettes ordre på denne måde, det skal ske via OrdreRegistret, ellers nedskrives Stock på WoodPellet ikke automatisk
//Her gør vi det manuelt:
woodPellet.Stock -= order.Amount;


//------------------------------------------------ WoodPelletRegister -----------------------------------------------------------------

//Her tilføjer vi de 2 første woodpellet objekter til registret med AddWoodPellet metoden
//Bemærk at metoden er statisk, derfor kalder vi den direkte gennem klassen og ikke igennem et objekt af klassen
WoodPelletRegister.AddWoodPellet(woodPellet);
WoodPelletRegister.AddWoodPellet(woodPellet1);

//Her tilføjes yderligt 3 objekter til registret. Denne gang via den "overloadede" metode AddWoodPellet.
//Bemærk når et metodenavn er overloaded betyder det at der er flere versioner af metoden med samme navn. Alle metoderne har forskellig "signatur"
//i forbindelse med overloadning betyder det at parameter-listen er forskellig.
WoodPelletRegister.AddWoodPellet(new WoodPellet("BioWood", "Premium", "8mm", 5995.00, "4,97 kwh/kg", "4,1%", 15, "1 Palle indeholder 64 poser af 15 kg"));
WoodPelletRegister.AddWoodPellet(new WoodPellet("HeatPellets", "High", "8mm", 5495.00, "4,83 kwh/kg", "4,5%", 2, "1 Palle indeholder 64 poser af 15,5 kg"));
WoodPelletRegister.AddWoodPellet(new WoodPellet("HeatPellets", "Medium", "6mm", 5295.00, "4,82 kwh/kg", "4,4%", 12, "1 Palle indeholder 64 poser af 15,2 kg"));


//Her udskrives woodpellet registret vha en foreach løkke 
//Bemærk selve listen med WoodPellt objekterne hentes med den statiske GetWoodPellets metode:
Console.WriteLine("WoodPelletRegister:");
foreach(WoodPellet pellet in WoodPelletRegister.GetWoodPellets())
{
    Console.WriteLine(pellet);
    Console.WriteLine();
}



//------------------------------------------------- OrderRegister -----------------------------------------------------------------------------

//Når der skal oprettes en ny ordre anvendes den statiske AddOrder metode i klassen OrderRegister
//Som argument skal den have et WoodPellet objekt - det hentes fra WoodPelletRegistret (her det objekt der har Id = 1)
OrderRegister.AddOrder(WoodPelletRegister.GetWoodPelletById(1), customer, 3, new DateOnly(2022, 10, 12), new DateOnly(2022, 11, 24), customer.Address);

//Her opretter vi en ny ordre på en WoodPellet med Id=2 til samme kunde, men til en ny adresse: 
OrderRegister.AddOrder(WoodPelletRegister.GetWoodPelletById(2), customer, 1, new DateOnly(2022, 10, 12), new DateOnly(2022, 11, 24), new Address("Sommerhusvej", "H42", "SommerBy", "9999"));


//Her udskrives order registret vha en foreach løkke:
Console.WriteLine("OrderRegister:");
foreach (Order aOrder in OrderRegister.GetOrders())
{
    Console.WriteLine(aOrder);
    Console.WriteLine();
}
Console.WriteLine();

//------------------------------------------------ WoodPelletRegister -- more -------------------------------------------------------------------

//Flere afprøvninger af metoderne fra WoodPelltsRegister.

//Her afprøves GetAllWoodPelletsByBrand metoden:
List<WoodPellet> bioWoodList = WoodPelletRegister.GetAllWoodPelletsByBrand("BioWood");

Console.WriteLine("Alle WoodPellets med Brand='BioWood':");
foreach (WoodPellet bioWood in bioWoodList)
{
    Console.WriteLine(bioWood);
    Console.WriteLine();
}
Console.WriteLine();



//Her slettes WoodPellet objektet med Id=4 fra registret
WoodPelletRegister.RemoveWoodPelletById(2);

Console.WriteLine("WoodPelletRegister efter sletning af WoodPellet med ID=2:");
foreach (WoodPellet pellet in WoodPelletRegister.GetWoodPellets())
{
    Console.WriteLine(pellet);
    Console.WriteLine();
}
Console.WriteLine();

//Her slettes alle WoodPellet objekter med Brand="BioWood":
WoodPelletRegister.RemoveWoodPelletsByBrand("biowood");

Console.WriteLine("WoodPelletRegister efter sletning af WoodPellets med Brand='BioWood':");
foreach (WoodPellet pellet in WoodPelletRegister.GetWoodPellets())
{
    Console.WriteLine(pellet);
    Console.WriteLine();
}
Console.WriteLine();